' * Show command v2.0 by Juri Fossaroli *
a$=MM.CmdLine$
If a$="" Then Input "input filename to show";a$

parsecommands:
fname$="":destfname$="":ext$="":pause=0:hexmode=0:verbose=0:dst=0:pss=1
If Left$(a$,1)="/" Then
  pss=2
  Do
  a1$=LCase$(Mid$(a$,pss,1))
  If a1$="?" Or a1$="i" Then GoTo help
  If a1$="p" Then pause=1
  If a1$="h" Then hexmode=1
  If a1$="v" Then verbose=1
  If a1$=" " Then pss=pss+1:GoTo fls
  pss=Pss+1
  Loop
EndIf

fls:
dst=Instr(a$,">"):fname$=LCase$(Right$(a$,Len(a$)-pss+1))
If dst>0 Then
  destfname$=LCase$(Right$(a$,Len(a$)-dst))
  fname$=LCase$(Mid$(a$,pss,Len(a$)-(Len(a$)-dst+pss+1)))
EndIf
ext$=LCase$(Right$(a$,4))
GoTo main

help:
  ? "Show command v2.0 by Juri Fossaroli"
  ? "Use this command to print text files on screen or display bmp files":?
  ? "Usage:":?:?">Show [option] filename [>outputfile]":?
  ? "Options:":?
  ? "/? or /i or /I : this help"
  ? "/p or /P       : pause text every page, normally text is showed continously"
  ? "/v or /V       : verbose mode, display a message when text is paused"
  ? "/h or /H       : display the file in Hex format":?
  ? "if no filename is specified then you'll be asked for one, you can use an"
  ? "option too placing it before the filename"
  ? "If no options and the file is a BMP file it will be displayed":?
  ? "Options can be mixed!! example: SHOW /PVH filename.jpg"
  ? "display the file 'filename.jpg' in hex mode, paused verbose"
  ? "If verbose mode is specified but pause mode is not specified then it will"
  ? "be ignored (example SHOW /V filename.bas)"
  ? "you can redirect the output to a filename using the special character '>'"
  ? "example 'SHOW /H file.jpg >outfile.hex' will save the hex output in file"
  ? "'outfile.hex'":?:End

main:
max=2800:blip=0:ln=0:sv=0
If hexmode=1 Then b$="":max=0
If ext$=".bmp" And max>0 Then
       LoadBMP fname$
       GoSub waitkey
       End
EndIf
Open fname$ For input As 1
If Len(destfname$)>0 Then sv=1:Open destfname$ For output As 2
If hexmode=1 GoTo hxx
Do
a$=Input$(1,#1)
If a$=Chr$(13) Then max=max-(79-Pos)
max=max-1:If sv=1 Then ? #2,a$; Else ? a$;
If pause=1 And max=0 Then GoSub waitkey
If max=0 Then max=2800
If Eof(#1)=-1 And sv=0 Then Close 1:End
If Eof(#1)=-1 And sv=1 Then Close 1:Close 2:End
Loop

hxx:
maxx=0
Do
a$=Input$(1,#1):z$="":zz$=""
If maxx <4096 Then z$="0"
If maxx <256 Then z$="00"
If maxx <16 Then z$="000"
If max=0 And sv=0 Then Font 1,,1:? " 0x"+z$+Hex$(maxx)+Tab(2);:Font 1,,0:? " : ";
If max=0 And sv=1 Then ? #2," 0x"+z$+Hex$(maxx)+Tab(2)+" : ";
If Asc(a$)<16 Then zz$="0"
If sv=1 Then ? #2,zz$+Hex$(Asc(a$))+" "; Else ? zz$+Hex$(Asc(a$))+" ";
If Asc(a$)>127 Then ot=1
a$=Chr$(Asc(a$) And 127)
If Asc(a$)=127 Then a$=" "
If Asc(a$)<32 Then a$=" "
If ot=1 Then a$=Chr$(128)+Chr$(199)+a$+CLR$(7,0):ot=0
b$=b$+a$:max=max+1
If max=16 And sv=0 Then max=0:? Chr$(34)+b$+Chr$(34):b$="":ln=ln+1
If max=16 And sv=1 Then max=0:? #2,Chr$(34)+b$+Chr$(34):b$="":ln=ln+1
If Eof(#1)=-1 And max<16 And sv=0 Then ? Tab(60)Chr$(34)+b$+Chr$(34):Close 1:End
If Eof(#1)=-1 And max<16 And sv=1 Then
  ? #2,Tab(60)Chr$(34)+b$+Chr$(34):Close 1:Close 2:End
EndIf
If Eof(#1)=-1 And sv=0 Then Close 1:End
If Eof(#1)=-1 And sv=1 Then Close 1:Close 2:End
If ln=35 And pause=1 Then ln=0: GoSub waitkey
maxx=maxx+1
Loop

waitkey:
If sv=1 Then Return
If verbose=0 GoTo sotto
If blip=1 Then Print @(0,35*12)Space$(29)"Press a key to continue"Space$(28)
If blip=500 Then Print @(0,35*12)Space$(60)
If blip=999 Then blip=0
blip=blip+1:If Asc(Inkey$)=0 GoTo waitkey
? @(0,35*12)Space$(60)@(0,34*12)"":Return

sotto:
If Asc(Inkey$)=0 GoTo sotto
Return

